VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MC"
   ClientHeight    =   5535
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7215
   Icon            =   "frmMain.frx":0000
   MaxButton       =   0   'False
   ScaleHeight     =   5535
   ScaleWidth      =   7215
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkCompressSectors 
      Caption         =   "Compress sectors"
      Height          =   255
      Left            =   3180
      TabIndex        =   10
      Top             =   720
      Width           =   1755
   End
   Begin RichTextLib.RichTextBox rtfLog 
      Height          =   3315
      Left            =   180
      TabIndex        =   9
      Top             =   1140
      Width           =   6855
      _ExtentX        =   12091
      _ExtentY        =   5847
      _Version        =   393217
      BackColor       =   0
      BorderStyle     =   0
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmMain.frx":08CA
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.CommandButton cmdCompress 
      Caption         =   "Compress"
      Default         =   -1  'True
      Height          =   375
      Left            =   180
      TabIndex        =   2
      Top             =   600
      Width           =   1635
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse..."
      Height          =   315
      Left            =   5880
      TabIndex        =   1
      Top             =   180
      Width           =   1155
   End
   Begin MSComDlg.CommonDialog cdlgMain 
      Left            =   3367
      Top             =   4980
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About"
      Height          =   375
      Left            =   180
      TabIndex        =   4
      Top             =   4980
      Width           =   1635
   End
   Begin VB.CheckBox chkWrite 
      Caption         =   "Write changes"
      Height          =   255
      Left            =   5580
      TabIndex        =   3
      Top             =   720
      Width           =   1395
   End
   Begin VB.PictureBox picProgressContainer 
      BackColor       =   &H80000010&
      Height          =   315
      Left            =   180
      ScaleHeight     =   255
      ScaleWidth      =   6795
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   4500
      Width           =   6855
      Begin MSComctlLib.ProgressBar prgBar 
         Height          =   255
         Left            =   0
         TabIndex        =   8
         Top             =   0
         Width           =   6795
         _ExtentX        =   11986
         _ExtentY        =   450
         _Version        =   393216
         Appearance      =   0
         Scrolling       =   1
      End
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   375
      Left            =   5400
      TabIndex        =   5
      Top             =   4980
      Width           =   1635
   End
   Begin VB.TextBox txtWAD 
      Height          =   315
      Left            =   1020
      TabIndex        =   0
      Top             =   180
      Width           =   4815
   End
   Begin VB.Label lblFile 
      Caption         =   "File"
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   240
      Width           =   675
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


' Sidedef
Private Type SideDef
    XOffs As Integer
    YOffs As Integer
    UpperTxt As String * 8
    LowerTxt As String * 8
    MiddleTxt As String * 8
    SecRef As Integer
End Type

' Hexen\Doom linedef
Private Type LineDef
    StartV As Integer
    EndV As Integer
    Flags As Integer
    lType As Integer
    lTag As Integer
    Action As Byte
    Args1 As Byte
    Args2 As Byte
    Args3 As Byte
    Args4 As Byte
    Args5 As Byte
    SideDef1 As Integer
    SideDef2 As Integer
End Type

' Sector
Private Type Sector
    FloorHeight As Integer
    CeilHeight As Integer
    FloorText As String * 8
    CeilText As String * 8
    LightLevel As Integer
    Special As Integer
    Tag As Integer
End Type

' Map info
Private Type MapInfo
    LumpNum As Long
    LumpName As String
    HexenMode As Boolean
End Type


' Structure sizes
Private Const LEN_SIDEDEF = 30
Private Const LEN_HLINEDEF = 16
Private Const LEN_DLINEDEF = 14
Private Const LEN_SECTOR = 26


' Add a line to the log
Private Sub AddLog(ByVal AddText As String, Optional ByVal Indent As Long = 0)

    rtfLog.Text = rtfLog.Text & Space$(Indent) & AddText & vbCrLf
    rtfLog.SelStart = Len(rtfLog.Text)
    rtfLog.Refresh

End Sub


' Apply compression to a WAD file
Private Sub Compress(ByVal WadFile As String)

    Dim A As Long
    Dim B As Long
    Dim C As Long
    Dim D As Long
    Dim FileNum As Long
    
    Dim WadType As String
    Dim nLumps As Long
    Dim BakFile As String
   
    Dim Percentage As Long
    Dim OldPercentage As Long
    
    Dim Wad As New clsWad
    Dim Wad2 As New clsWad
    Dim Maps() As MapInfo
    Dim nMaps As Long
    
    Dim SideDefs() As SideDef
    Dim nSideDefs As Long
    Dim OldnSideDefs As Long
    Dim SidedefLump As Long
    
    Dim Sectors() As Sector
    Dim nSectors As Long
    Dim OldnSectors As Long
    Dim SectorLump As Long
    
    Dim LineDefs() As LineDef
    Dim nLineDefs As Long
    Dim LinedefLump As Long
    
    
    ' Back up WAD
    If chkWrite.Value = 1 Then
        AddLog "Backing up WAD..."
        BakFile = StripExt(WadFile) & ".bak"
        If Dir$(BakFile) <> "" Then Kill BakFile
        FileCopy WadFile, BakFile
    End If
    
    
    ' OpenWAD
    AddLog "Opening WAD file..."
    Wad.OpenWad WadFile
    
    ' Find map lumps
    AddLog "Analysing " & WadFile & "..."
    For A = 0 To Wad.WadLumps
    
        ' Thing lump, previous must be map lump
        If Wad.LumpName(A) = "THINGS" Then
            ReDim Preserve Maps(nMaps)
            nMaps = nMaps + 1
            
            Maps(nMaps - 1).LumpName = Wad.LumpName(A - 1)
            Maps(nMaps - 1).LumpNum = A - 1
            Maps(nMaps - 1).HexenMode = False
        
        ' Behavior lump, current map must be Hexen format
        ElseIf Wad.LumpName(A) = "BEHAVIOR" And nMaps > 0 Then
            Maps(nMaps - 1).HexenMode = True
            
        End If
        
    Next A
    
    
    ' Cycle through all maps
    For A = 0 To nMaps - 1
    
        AddLog "Loading map " & Maps(A).LumpName & "..."
    
        ' Display map mode
        If Maps(A).HexenMode = True Then
            AddLog "Map is in Hexen format", 2
        Else
            AddLog "Map is in Doom format", 2
        End If
        
        
        ' Read sidedefs
        SidedefLump = Maps(A).LumpNum + 3
        nSideDefs = (Wad.LumpSize(SidedefLump) / LEN_SIDEDEF) - 1
        OldnSideDefs = nSideDefs
        ReDim SideDefs(nSideDefs)

        FileNum = Wad.SeekLump(SidedefLump)
        Get #FileNum, , SideDefs()
        
        AddLog "Loaded " & nSideDefs & " sidedefs", 2
        
        
        If chkCompressSectors.Value = 1 Then
            
            ' Read Sectors
            SectorLump = Maps(A).LumpNum + 8
            nSectors = (Wad.LumpSize(SectorLump) / LEN_SECTOR) - 1
            OldnSectors = nSectors
            ReDim Sectors(nSectors)
    
            FileNum = Wad.SeekLump(SectorLump)
            Get #FileNum, , Sectors()
    
            AddLog "Loaded " & nSectors & " sectors", 2
            
        End If

        
        ' Load linedefs
        LinedefLump = Maps(A).LumpNum + 2
        
        ' Read Hexen linedefs
        If Maps(A).HexenMode = True Then
            
            nLineDefs = (Wad.LumpSize(LinedefLump) / LEN_HLINEDEF) - 1
            ReDim LineDefs(nLineDefs)
            
            ' Read properties
            FileNum = Wad.SeekLump(LinedefLump)
            For B = 0 To nLineDefs
            
                Get #FileNum, , LineDefs(B).StartV
                Get #FileNum, , LineDefs(B).EndV
                Get #FileNum, , LineDefs(B).Flags
                Get #FileNum, , LineDefs(B).Action
                Get #FileNum, , LineDefs(B).Args1
                Get #FileNum, , LineDefs(B).Args2
                Get #FileNum, , LineDefs(B).Args3
                Get #FileNum, , LineDefs(B).Args4
                Get #FileNum, , LineDefs(B).Args5
                Get #FileNum, , LineDefs(B).SideDef1
                Get #FileNum, , LineDefs(B).SideDef2
                
            Next B
            
        ' Read Doom linedefs
        ElseIf Maps(A).HexenMode = False Then
            
            nLineDefs = (Wad.LumpSize(LinedefLump) / LEN_DLINEDEF) - 1
            ReDim LineDefs(nLineDefs)
            
            ' Read properties
            FileNum = Wad.SeekLump(LinedefLump)
            For B = 0 To nLineDefs
            
                Get #FileNum, , LineDefs(B).StartV
                Get #FileNum, , LineDefs(B).EndV
                Get #FileNum, , LineDefs(B).Flags
                Get #FileNum, , LineDefs(B).lType
                Get #FileNum, , LineDefs(B).lTag
                Get #FileNum, , LineDefs(B).SideDef1
                Get #FileNum, , LineDefs(B).SideDef2
                
            Next B
            
        End If
        
        AddLog "Loaded " & nLineDefs & " linedefs", 2
        
        
        If chkCompressSectors.Value = 1 Then
        
            ' Start compression of sectors
            AddLog "Compressing sectors..."
    
            ' Setup progress indicator
            Percentage = 0
            OldPercentage = 0
            prgBar.Value = 0
    
            ' Cycle through each sector
            B = 0
            Do While B <= nSectors
    
                ' Update progress indicator
                Percentage = (B / nSectors) * 100
                If Percentage > OldPercentage Then
                    prgBar.Value = Percentage
                    OldPercentage = Percentage
                End If
                DoEvents
    
                C = 0
                Do While C <= nSectors
    
                    ' Watch out
                    If B > nSectors Then Exit Do
    
                    ' Compare sector for every aspect
                    If B <> C Then
                        If Sectors(B).FloorHeight = Sectors(C).FloorHeight Then
                            If Sectors(B).CeilHeight = Sectors(C).CeilHeight Then
                                If Sectors(B).Tag = Sectors(C).Tag Then
                                    If Sectors(B).Special = Sectors(C).Special Then
                                        If Sectors(B).FloorText = Sectors(C).FloorText Then
                                            If Sectors(B).CeilText = Sectors(C).CeilText Then
                                                If Sectors(B).LightLevel = Sectors(C).LightLevel Then
        
                                                    ' Reassign
                                                    For D = 0 To nSideDefs
                                                        If SideDefs(D).SecRef = C Then SideDefs(D).SecRef = B
                                                    Next D
        
                                                    ' Rereference removed one
                                                    For D = 0 To nSideDefs
                                                        If SideDefs(D).SecRef = nSectors Then SideDefs(D).SecRef = C
                                                    Next D
        
                                                    ' Remove it
                                                    If C <> nSectors Then Sectors(C) = Sectors(nSectors)
                                                    ReDim Preserve Sectors(nSectors - 1)
                                                    nSectors = nSectors - 1
                                                    
                                                    If C > 0 Then C = C - 1
        
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
    
    
                C = C + 1
                Loop
    
    
                B = B + 1
            Loop
    
            prgBar.Value = 0
    
    
            ' Report compression ratio
            AddLog "Compression ratio: " & CInt((nSectors / OldnSectors) * 100) & "%"
            
        End If
        
        
        
        ' Start compression of sidedefs
        AddLog "Compressing sidedefs..."
        
        ' Setup progress indicator
        Percentage = 0
        OldPercentage = 0
        prgBar.Value = 0
                
        ' Cycle through each sidedef
        B = 0
        Do While B <= nSideDefs
        
            ' Update progress indicator
            Percentage = (B / nSideDefs) * 100
            If Percentage > OldPercentage Then
                prgBar.Value = Percentage
                OldPercentage = Percentage
            End If
            DoEvents
            
            C = 0
            Do While C <= nSideDefs
        
                ' Watch out
                If B > nSideDefs Then Exit Do
        
                ' Compare sidedefs for every aspect
                If B <> C Then
                    If SideDefs(B).SecRef = SideDefs(C).SecRef Then
                        If SideDefs(B).LowerTxt = SideDefs(C).LowerTxt Then
                            If SideDefs(B).UpperTxt = SideDefs(C).UpperTxt Then
                                If SideDefs(B).MiddleTxt = SideDefs(C).MiddleTxt Then
                                    If SideDefs(B).XOffs = SideDefs(C).XOffs Then
                                        If SideDefs(B).YOffs = SideDefs(C).YOffs Then
                
                                            ' Reassign
                                            For D = 0 To nLineDefs
                                                If LineDefs(D).SideDef1 = C Then LineDefs(D).SideDef1 = B
                                                If LineDefs(D).SideDef2 = C Then LineDefs(D).SideDef2 = B
                                            Next D

                                            ' Rereference removed one
                                            For D = 0 To nLineDefs
                                                If LineDefs(D).SideDef1 = nSideDefs Then LineDefs(D).SideDef1 = C
                                                If LineDefs(D).SideDef2 = nSideDefs Then LineDefs(D).SideDef2 = C
                                            Next D
                                            
                                            ' Remove it
                                            If C <> nSideDefs Then SideDefs(C) = SideDefs(nSideDefs)
                                            ReDim Preserve SideDefs(nSideDefs - 1)
                                            nSideDefs = nSideDefs - 1
                                            
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            
            
            C = C + 1
            Loop
            
            
            B = B + 1
        Loop
        
        prgBar.Value = 0
        
        
        ' Report compression ratio
        AddLog "Compression ratio: " & CInt((nSideDefs / OldnSideDefs) * 100) & "%"
        
        
        
        ' Write back data
        If chkWrite.Value = 1 Then
        
            AddLog "Writing sidedefs..."
            FileNum = Wad.SeekLump(SidedefLump)
            Put #FileNum, , SideDefs()
            Wad.LumpSize(SidedefLump) = (nSideDefs + 1) * LEN_SIDEDEF
            
            
            If chkCompressSectors.Value = 1 Then
                AddLog "Writing sectors..."
                FileNum = Wad.SeekLump(SectorLump)
                Put #FileNum, , Sectors()
                Wad.LumpSize(SectorLump) = (nSectors + 1) * LEN_SECTOR
            End If
            
            
            AddLog "Writing linedefs..."
            
            ' Write Hexen linedefs
            If Maps(A).HexenMode = True Then
                
                Wad.LumpSize(LinedefLump) = (nLineDefs + 1) * LEN_HLINEDEF
                
                ' Write properties
                FileNum = Wad.SeekLump(LinedefLump)
                For B = 0 To nLineDefs
                
                    Put #FileNum, , LineDefs(B).StartV
                    Put #FileNum, , LineDefs(B).EndV
                    Put #FileNum, , LineDefs(B).Flags
                    Put #FileNum, , LineDefs(B).Action
                    Put #FileNum, , LineDefs(B).Args1
                    Put #FileNum, , LineDefs(B).Args2
                    Put #FileNum, , LineDefs(B).Args3
                    Put #FileNum, , LineDefs(B).Args4
                    Put #FileNum, , LineDefs(B).Args5
                    Put #FileNum, , LineDefs(B).SideDef1
                    Put #FileNum, , LineDefs(B).SideDef2
                    
                Next B
                
            ' Write Doom linedefs
            ElseIf Maps(A).HexenMode = False Then
                
                Wad.LumpSize(LinedefLump) = (nLineDefs + 1) * LEN_DLINEDEF
                
                ' Write properties
                FileNum = Wad.SeekLump(LinedefLump)
                For B = 0 To nLineDefs
                
                    Put #FileNum, , LineDefs(B).StartV
                    Put #FileNum, , LineDefs(B).EndV
                    Put #FileNum, , LineDefs(B).Flags
                    Put #FileNum, , LineDefs(B).lType
                    Put #FileNum, , LineDefs(B).lTag
                    Put #FileNum, , LineDefs(B).SideDef1
                    Put #FileNum, , LineDefs(B).SideDef2
                    
                Next B
                
            End If
    
            ' Write WAD header
            Wad.WriteDirectory
            
        End If
    
    Next A
    
    
    ' Close WAD
    AddLog "Closing " & WadFile
    Set Wad = Nothing
    
    
    ' Clean the WAD file
    If chkWrite.Value = 1 Then
    
        AddLog "Cleaning WAD..."
        
        
        ' Kill original, open bak file
        If Dir$(App.Path & "\temp.Wad") <> "" Then Kill App.Path & "\temp.wad"
        FileCopy WadFile, App.Path & "\temp.wad"
        Kill WadFile
        Wad.OpenWad App.Path & "\temp.wad"
        
        ' Create new WAD of proper type
        If Wad.WadType = 0 Then
            WadType = "IWAD"
        ElseIf Wad.WadType = 1 Then
            WadType = "PWAD"
        End If
        Wad2.CreateWad WadFile, WadType
        
        
        ' Copy over each lump
        AddLog "Copying lumps", 2
        
        nLumps = Wad.WadLumps
        For B = 0 To nLumps
            prgBar.Value = (B / nLumps) * 100
            DoEvents
            
            Wad2.AddLump Wad.LumpName(B), Wad.ReadLump(B)
        Next B
        Wad2.WriteDirectory
    
    
        ' Cleanup
        prgBar.Value = 0
        Set Wad = Nothing
        Set Wad2 = Nothing
        Kill App.Path & "\temp.wad"
        
        AddLog "Gained " & FileLen(BakFile) - FileLen(WadFile) & " bytes."
        
    End If
    
    
    AddLog "Done."

End Sub


' Sector compression warning
Private Sub chkCompressSectors_Click()

    If chkCompressSectors.Value = 1 Then
        MsgBox "WARNING: Compressing sectors can lead to unpredictable results in some source ports. Testing the map(s) afterwards is advised.", vbOKOnly Or vbExclamation
    End If

End Sub


' About
Private Sub cmdAbout_Click()

    MsgBox "Map Compressor (for Doom\Hexen)" & vbCrLf & "Version " & App.Major & "." & App.Minor & " build " & App.Revision & vbCrLf & vbCrLf & "By Dennis 'Exl' Meuwissen", vbOKOnly Or vbInformation

End Sub


' Browse for a WAD file
Private Sub cmdBrowse_Click()

    ' Trap errors
    On Error GoTo WadDialogError

    ' Setup the common dialog control
    With cdlgMain
        .CancelError = True
        .DefaultExt = 1
        .DialogTitle = "Select a WAD file"
        .Filter = "WAD files (*.wad)|*.wad|All files (*.*)|*.*"
        .Flags = cdlOFNHideReadOnly Or cdlOFNLongNames Or cdlOFNNoReadOnlyReturn
        .InitDir = App.Path
        .ShowOpen
    End With

    ' Return the filename
    If LCase$(cdlgMain.FileName) <> "" Then txtWAD.Text = LCase$(cdlgMain.FileName)

    Exit Sub


WadDialogError:
    
End Sub


' Start compression
Private Sub cmdCompress_Click()

    txtWAD.Text = Trim$(txtWAD.Text)
    
    ' Check if file exists
    If Dir$(txtWAD.Text) = "" Or txtWAD.Text = "" Then
        AddLog "File does not exist!"
        Exit Sub
    End If
    
    ' Writing changes
    If chkWrite.Value = 0 Then If MsgBox("Changes will not be written.", vbOKCancel Or vbInformation) = vbCancel Then Exit Sub
    
    
    cmdCompress.Enabled = False
    cmdExit.Enabled = False
    cmdAbout.Enabled = False
    cmdBrowse.Enabled = False
    chkWrite.Enabled = False
    txtWAD.Enabled = False
    
    frmMain.Refresh
    Compress txtWAD.Text
    
    cmdCompress.Enabled = True
    cmdExit.Enabled = True
    cmdAbout.Enabled = True
    cmdBrowse.Enabled = True
    chkWrite.Enabled = True
    txtWAD.Enabled = True

End Sub


' Exit\End
Private Sub cmdExit_Click()

    End

End Sub


' Strip extension from a filename
Private Function StripExt(ByVal InString As String) As String

    StripExt = Left$(InString, InStrRev(InString, ".") - 1)

End Function


' Form load event
Private Sub Form_Load()

    AddLog "Map Compressor (for Doom\Hexen)"
    AddLog "Version " & App.Major & "." & App.Minor & " build " & App.Revision
    AddLog ""
    
    rtfLog.SelStart = 0
    rtfLog.SelLength = Len(rtfLog.Text)
    rtfLog.SelColor = RGB(192, 192, 192)

End Sub
